// pages/setAvatarNickname/setAvatarNickname.js
var miucms = require('../../utils/miucms.js');
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        avatarUrl: '',
        nickname: "",
        islogin: false,
        isloginBtnState: false,
        informationState: false,
    },

    /**
     * 生命周期函数--监听页面加载
     */
    options: {},
    onLoad: function (options) {
        this.options = options
        miucms.pageStart(app).then(() => {
            const globalData = app.globalData || {}
            const user = globalData.user || {}
            this.setData({
                avatarUrl: user.avatar || '../../img/defaultAvatar.png',
                nickname: user.nickname || '',
                isIndex: options.isIndex ? true : false, // 判断是否顶部返回键的
                token: options.token,
                islogin: app.globalData.user.uid > 0 ? true : false,
            })
        })
    },

    onChooseAvatar(e) {
        let avatarUrl = e.detail.avatarUrl
        avatarUrl = 'data:image/jpeg;base64,' + wx.getFileSystemManager().readFileSync(avatarUrl, "base64")
        this.setData({
            avatarUrl
        })

        miucms.request("https://passport.gter.net/api/user/uploadAvatar", {
            data: avatarUrl
        }).then(res => {
            if (res.code == 401) {
                wx.showToast({
                    title: res.message,
                    icon: "none"
                })
                this.openLoginBtnState()
                return
            }

            let data = res.data
            app.globalData.user = data.user
            app.globalData['setSate'] = true
        })
    },
    submitNickname() {
        miucms.request("https://passport.gter.net/api/user/updateNickname", {
            nickname: this.data.nickname
        }).then(res => {
            if (res.code == 401) {
                wx.showToast({
                    title: res.message,
                    icon: "none"
                })
                this.openLoginBtnState()
                return
            }
            if (res.code == 200) {
                let data = res.data
                app.globalData.user = data.user
                app.globalData.setSate = true
                if (this.data.isIndex) {
                    wx.navigateBack({
                        delta: 1,
                        fail: function () {
                            wx.navigateTo({
                                url: '/pages/projectLibrary/projectLibrary',
                            })
                        }
                    })
                    return
                }

                if (data.status == 1 || data.status == 2) {
                    wx.redirectTo({
                        url: '/pagesSquare/pages/PCAuthorization/PCAuthorization?token=' + this.data.token + "&status=" + data.status,
                    })
                } else {
                    wx.navigateBack({
                        delta: 1,
                        fail: function () {
                            wx.navigateTo({
                                url: '/pages/projectLibrary/projectLibrary',
                            })
                        }
                    })
                }

            } else {
                wx.showToast({
                    icon: "none",
                    title: res.message,
                })
            }
        })
    },

    // 关闭授权登录事件
    popClose() {
        this.setData({
            isloginBtnState: !this.data.isloginBtnState
        })
    },

    // 打开 登录弹窗
    openLoginBtnState() {
        this.setData({
            isloginBtnState: true
        })
    },

    userClickLogin(e) {
        let data = e.detail.data
        this.setData({
            islogin: true,
            isloginBtnState: false,
            informationState: data.regdatastep == 'success' ? false : true,
        })

        this.onLoad(this.options)
    },

    // 子组件传值 修改 完善信息组件的状态  
    revampInformationState() {
        this.setData({
            informationState: false
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {},

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {},

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {},

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {},

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {},

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {},
})